#import <objectbase.h>
#import <activity.h>
#import <collections.h>
#import "graph.h"
#import <objectbase/Swarm.h>
#import <gui.h>

#define ZOOMFACTORX  50
#define ZOOMFACTORY  50
#define STAGEWIDTH  10
#define STAGEDEPTH  8


@interface ModelSwarm : Swarm {
  int population ;

  id <ActionGroup> modelActions;
  id <Schedule> modelSchedule;
  id <Schedule> outputSchedule;

  int eventRate ;
  int maxK ;

  id <Canvas> graphCanvas;
  DiGraph * theNet;
  id entityList;
  long int currentTime;
  FILE *outputFile;
  char outputFileName[50];

}

+createBegin: (id) aZone;
-createEnd;		

- getRandomEntity ;
- getTheNet ;
- hideDiGraph; 
- showDiGraph;

- getEntityList ;

- setGraphCanvas: aCanvas;


- (void)writeReportDataHeader;
- (void)writeReportData;

- buildObjects;
- buildActions;

- scheduleStepAt: (int)n For: aNode;
- activateIn: (id) swarmContext;

- (void)step;

- (long int)getTime;

@end

